# Lecture code

>**❗NOTE: To make things easy for yourself, DO NOT fork this repo. That will make it easy for you have an updated version of the lecture code at all times and avoid accidentally creating conflicts by pushing to the fork.**

## Norsk (<a href="#english">English below</a>)
Dette repoet inneholder alle filene vi bruker/lager under forelesninger.
Etter hver forelesning oppdateres prosjektet med de relevante filene.

## Hvordan beholder jeg de lokale endringene mine når nye forelesningsnotater legges til dette repoet?
Hvis du gjør endringer på dette repoet kan det oppstå konflikter hvis både du og foreleser har endre på de samme filene og du så prøver å pulle disse endringene for å oppdatere din klone av repoet.

> ❗Alle disse metodene innebærer å klone lecture code repoet **UTEN Å FORKE**. Det gjør det lettere å unngå å ved et uhell pushe endringer og skape konflikter.

Hvordan du håndterer dette er avhengig av hva du har tenkt å gjøre med koden:
* [Jeg vil gjøre endringer på koden og lagre disse i gitlab.](#1-lag-et-separat-prosjekt-med-endringer)
* [Jeg vil gjøre endringer på koden men bare lagre dem lokalt.](#2-bruk-pull-og-håndter-endringer-manuelt)
* [Jeg vil gjøre endringer på koden men ikke lagre dem.](#3-slett-klonen-og-klon-på-nytt)
* [Jeg vil ikke gjøre endringer på koden.](#4-ikke-gjør-endringer)
---
### 1. Lag et separat prosjekt med endringer
>❗**Ikke fork dette repoet**. Da unngår du å måtte oppdatere forken din når det lastes opp endringer.
1. Klon lecture code repoet **uten å forke**.
2. Lag ditt eget prosjekt på git som er tiltenkt endringer.
3. Kopier over filene du ønsker fra din klone av lecture code repoet og lim dem inn i ditt eget prosjektet. Husk å få med viktige filer som pom.xml første gangen du gjør dette.
4. Når foreleser publiserer nye endringer på lecture code, bruker du kommandoen `git pull` i terminalen for å oppdatere klonen din.
5. Kopier koden du ønsker inn i ditt eget prosjektet. Du har nå ingen konflikter og får beholde endringene dine uten problemer.
---
### 2. Bruk pull og håndter konflikter manuelt
>❗**Ikke fork dette repoet**. Da unngår du å måtte oppdatere forken din når det lastes opp endringer.

**Hvis du vil pushe endringene dine til gitlab, bruk den forrige metoden**. Denne metoden vil gjøre det vanskeligere.

**Hvis du ikke har tenkt å pushe endringene dine til git**, kan du spare deg selv for bryet med å kopiere filer ved å bare bruke `git pull` og så manuelt håndtere konflikter. 

1. Klon lecture code repoet **uten å forke**.
2. Skriv endringene dine direkte i lecture code prosjektet. Lagre alle filene du gjorde endringer på lokalt i din IDE.
3. Når du puller filer som lager konflikt, kreves det at du bruker **commit eller stash** på endringene som beskrevet under:

#### Commit eller stash
Å bruke **commit** burde vært kjent fra før. Dette er det vi gjør før vi kan pushe endringer til gitlab repoet vårt.


4. Bruk kommandoen `git add .` i terminalen for å stage endringene (de fleste IDEer har innebygd funksjonalitet for å stage endringer).
5. Bruk kommandoen `git commit -m "YOUR COMMENT HERE"` for å commite endringene. **Det vil ikke være mulig å pushe endringene**. Hvis du vil pushe endringene til git, bruk [metode 1](#1-lag-et-separat-prosjekt-med-endringer).
6. Bruk kommandoen `git pull` for å hente endringene fra lecture code repoet. 
7. [Håndter merge konflikter manuelt](https://stackoverflow.com/questions/38216541/visual-studio-code-how-to-resolve-merge-conflicts-with-git).
---
Å **stashe** betyr å "legge vekk" de lokale endringene så du kan jobbe på andre ting og hente endringene tilbake når du trenger dem. Denne metoden gjør i dette tilfellet akkurat det samme som å commite (merk at disse kommandoene ikke er ekvivalente).

4. Bruk kommandoen `git stash` i terminalen din for å stashe vekk endringene. Prosjektet ditt tilbakeføres til siste commit og endringene dine forsvinner midlertidig.
5. Bruk kommandoen `git pull` i terminalen for å hente endringene fra lecture code repoet.
6. Bruk kommandoen `git stash pop` for å hente frem igjen endringene du stashet.
7. [Håndter konflikter manuelt](https://stackoverflow.com/questions/38216541/visual-studio-code-how-to-resolve-merge-conflicts-with-git).

**Det vil ikke være mulig å pushe endringene**. Hvis du vil pushe endringene til git, bruk [metode 1](#1-lag-et-separat-prosjekt-med-endringer).

---
### 3. Slett klonen og klon på nytt
>❗**Ikke fork dette repoet**. Da unngår du å måtte oppdatere forken din når det lastes opp endringer.

**Hvis du ikke føler for å beholde endringene du har gjort på forelesningskoden**, kan du enkelt nok slette klonen din og klone på nytt når nye endringer lastes opp.

---
### 4. Ikke gjør endringer
>❗**Ikke fork dette repoet**. Da unngår du å måtte oppdatere forken din når det lastes opp endringer.

**Hvis du ikke har tenkt å gjøre endringer på forelesningskoden**, men du vil ha prosjektet lokalt, kan du bruke kommandoen `git pull` i terminalen for å oppdatere klonen din (eller bruke [metode 3](#3-slett-klonen-og-klon-på-nytt)).

---
## English
This repository contains all files we use/make during lectures.
After each lecture we will update the project with the relevant files.

## How do I keep my local changes when new lecture notes are added to this repository?
If you make changes to this repo, there might become conflicts if both you and the lecturer have changed the same files, and you then try to pull these changes to update your clone of the repo.

> ❗All these methods involves cloning the lecture code repo **WITHOUT FORKING**. This makes it easier to avoid accidentally pushing changes to the fork and creating conflicts.

How to handle this depends on what you intend to do with the code:
* [I want to make changes to the code and store them in gitlab.](#1-create-a-separate-project-with-changes)
* [I want to make changes to the code but only store them locally.](#2-use-pull-and-manually-deal-with-conflicts)
* [I want to make changes to the code but not store them.](#3-delete-the-clone-and-re-clone)
* [I don't want to make changes to the code.](#4-dont-make-changes)


### 1. Create a separate project with changes
> ❗**Do not fork this repo.** Then you avoid having to update your fork when changes are published.

1. Clone the lecture code repo **without forking**.
2. Create your own project in git that is intended for changes.
3. Copy over the files you want from your clone of the lecture code repo and paste them into your own project. Remember to copy important files like pom.xml the first time you do this.
4. When the lecturer publishes new changes to the lecture code repo, use the command `git pull` in the terminal to update your clone.
5. Copy the code you want into your own project. You now have no conflicts and get to keep your own changes without any problems.

---

### 2. Use pull and manually deal with conflicts.
> ❗**Do not fork this repo.** Then you avoid having to update your fork when changes are published.

**If you want to push your changes to gitlab, use the previous method**. This method will make it hard to do so.

**If you don't intend on pushing your changes to git**, you can save yourself the trouble of copying files by using `git pull` and then manually dealing with the conflicts.

1. Clone the lecture code repo **without forking**.
2. Write your changes directly in the lecture code project. Save all the files you made changes to locally in you IDE.
3. When you pull files that cause conflict, you are required to either **commit or stash** the changes as described below:


#### Commit or stash
**Commiting** should be familiar by now. This is what we do before we can push any changes to our gitlab repo.

4. Use the command `git add .` in the terminal to stage the changes (most IDEs have built in functionality to stage changes).
5. Use the command `git commit -m "YOUR COMMENT HERE"` to commit the changes. **It will not be possible to push the changes**. If you want to push changes, use [method 1](#1-create-a-seaparate-project-with-changes).
6. Use the command `git pull` to get the changes from the lecture code repo.
7. [Handle merge conflicts manually](https://stackoverflow.com/questions/38216541/visual-studio-code-how-to-resolve-merge-conflicts-with-git).

---

**Stashing** means "putting away" you local changes so you can work on other things and then get these changes back when you need them. This method essentially does the same as commiting in this case (note that these methods are not equivalent).

4. Use the command `git stash` in the terminal to stash away the changes. Your project will revert back to the last commit, and your changes will temporarily disappear.
5. Use the command `git pull` to get the changes from the lecture code repo.
6. Use the command `git stash pop` to reinstate your local changes. 
7. [Handle conflicts manually](https://stackoverflow.com/questions/38216541/visual-studio-code-how-to-resolve-merge-conflicts-with-git).

**It will not be possible to push the changes**. If you want to push changes, use [method 1](#1-create-a-seaparate-project-with-changes).

---

### 3. Delete the clone and re-clone
> ❗**Do not fork this repo.** Then you avoid having to update your fork when changes are published.

**If you don't feel the need to keep your changes to the lecture code**, you can simply delete your clone and clone over again whenever new updates are added.

---

### 4. Don't make changes
> ❗**Do not fork this repo.** Then you avoid having to update your fork when changes are published.

**If you don't intend on making any changes to the lecture code**, but you want to have a local save, there will be no conflict issues and you can just use `git pull` in your terminal to update your clone (or use [method 3](#3-delete-the-clone-and-re-clone)).
