package forelesning10;

import java.time.LocalDate;
import java.util.ArrayList;
import java.util.List;

public class ShoppingList implements IShoppingList {

	private ArrayList<ShoppingItem> handleliste;
	private LocalDate date;
	
	public ShoppingList(LocalDate date) {
		handleliste = new ArrayList<ShoppingItem>();
		this.date=date;
	}
	
	@Override
	public List<ShoppingItem> getAllItems() {
		return new ArrayList<ShoppingItem>( handleliste);
	}

	@Override
	public void add(ShoppingItem item) {
		if(item==null)
			throw new IllegalArgumentException("item can not be null");
		handleliste.add(item);		
	}

	@Override
	public LocalDate getDate() {
		return date;
	}

	@Override
	public double totalPrice() {
		double sum=0.0;
		for(ShoppingItem item : handleliste) {
			sum += item.getPrice();
		}
		return sum;
	}

	@Override
	public int getItemCount(String itemName) {
		int count=0;
		for(ShoppingItem item : handleliste) {
			if(item.getName().equals(itemName))
				count++;
		}
		return count;
	}
}
