package lecture6_interface;

public class GhostPokemon implements IPokemon {

	int strength;
	int healthPoints;
	String pokemonName;
	
	GhostPokemon(String name, int strength){
		this.pokemonName = name;
		this.healthPoints = 100;
		this.strength = strength;
	}
	
	@Override
	public int getStrength() {
		return strength;
	}

	@Override
	public String getName() {
		return pokemonName;
	}

	@Override
	public int getCurrentHP() {
		return healthPoints;
	}

	@Override
	public boolean isAlive() {
		return healthPoints>0;
	}

	@Override
	public void damage(int damageTaken) {
        healthPoints -= damageTaken;
        if(healthPoints<0)
        	healthPoints = 0;
    }

	@Override
	public void attack(IPokemon target) {
        int dmg = Math.max(target.getCurrentHP()/2,1);
        target.damage(dmg);
    }
	
    @Override
    public String toString() {
        return pokemonName+" has "+healthPoints+" left."; 
    }

}
