package lecture6_interface;

public interface IPokemon {

	/**
     * Get name of the pokémon
     * @return name of pokémon
     */
	String getName();

    /**
     * Get strength of the pokémon
     * @return strength of pokémon
     */
    int getStrength();
    
    /**
     * Get current health points of pokémon
     * @return current HP of pokémon
     */
    int getCurrentHP();
    
    /**
     * Check if the pokémon is alive. 
     * A pokemon is alive if current HP is higher than 0
     * @return true if current HP > 0, false if not
     */
    boolean isAlive();
    
    /**
     * Damage the pokémon. This method reduces the number of
     * health points the pokémon has by <code>damageTaken</code>.
     * If <code>damageTaken</code> is higher than the number of current
     * health points then set current HP to 0.
     *
     * @param damageTaken
     */
    void damage(int damageTaken);
    
    /**
     * Attack another pokémon. The method conducts an attack by <code>this</code>
     * on <code>target</code>. Calculate the damage using the pokémons strength
     * and a random element. Reduce <code>target</code>s health.
     * 
     * If <code>target</code> has 0 HP then print that it was defeated.
     * 
     * @param target pokémon that is being attacked
     */
    void attack(IPokemon target);
    
	

}
