package lecture7_collections;

import java.util.Objects;

public class Book implements Comparable<Book>{

	String author;
	String title;
	String sortType;
	
	Book(String author, String title){
		this.author = author;
		this.title = title;
	}
	
	@Override
	public String toString() {
		return author+": "+title;
	}

	@Override
	public int hashCode() {
		return Objects.hash(author, title);
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		Book other = (Book) obj;
		return Objects.equals(author, other.author) && Objects.equals(title, other.title);
	}

	@Override
	public int compareTo(Book other) {
		int cmp = this.author.compareTo(other.author);
		if(cmp == 0) {
			cmp = this.title.compareTo(other.title);
		}
		return cmp;
	}
	
	
}
