package lecture7_collections;

import java.util.ArrayList;
import java.util.Collections;
import java.util.LinkedList;
import java.util.List;

public class Library {

	List<Book> books;
	
	Library(){
		books = new LinkedList<Book>();
		addBooks();
	}
	
	void addBooks() {
		books.add(new Book("Martin", "Objects"));
		books.add(new Book("Sondre", "Teaching"));
		books.add(new Book("Balder", "Vector"));
		books.add(new Book("Robert C. Martin", "Clean Code"));
		books.add(new Book("Eric Freeman", "Head First Design Patterns"));
		books.add(new Book("Yegor Bugayenko", "Elegant Objects"));
		books.add(new Book("Henrik Løvold", "Objektorientert programmering med Python"));
	}
	
	/**
	 * This method checks if the library contains a given book.
	 * @param wanted, the book to check for.
	 * @return true if an equal book exist, false otherwise
	 */
	boolean hasBook(Book wanted){
		return books.contains(wanted);
	}
	
	public static void main(String[] args) {
		Library mylib = new Library();
		System.out.println(mylib.books);
		
		List<Book> booklist = mylib.books;
		
		System.out.println(mylib.books.size());
		
		Collections.sort(booklist);
	
		System.out.println(booklist);
		
		Collections.sort(booklist, new BookComparatorTitleFirst());

		System.out.println(booklist);
}
}
