package lecture8_encapsulation;

public class TrafficLight {

	private boolean red;
	private boolean yellow;
	private boolean green;
	
	TrafficLight(){
		red=true;
		green=false;
		yellow=false;
	}

	TrafficLight(boolean red, boolean yellow, boolean green){
		if(!isValid(red,yellow,green)) {
			throw new IllegalArgumentException("The combination "+ makeString(red,yellow,green) +" is not a valid TrafficLight");
		}
		this.red=red;
		this.yellow=yellow;
		this.green=green;
	}
	
	
	private boolean isValid(boolean red, boolean yellow, boolean green) {
		if(red) {
			return !green;
		}
		else {
			return (green && !yellow) || (!green && yellow); 
		}
	}

	void next() {
		if(red) {
			if(!yellow) { //state 1
				yellow = true;
			}
			else { //state 2
				red=false;
				yellow=false;
				green=true;
			}
		}
		else {
			if(green) {//state 3
				green=false;
				yellow=true;
			}
			else {//state 4
				yellow=false;
				red=true;
			}
		}
	}
	
	@Override
	public String toString() {
		String s = makeString(red,yellow,green);
		return s;
	}

	private String makeString(boolean red, boolean yellow, boolean green) {
		String s = "";
		if(red) {
			s+="red";
		}
		if(green) {
			if(s.length()>0) {
				s+=", ";
			}
			s+="green";
		}
		if(yellow) {
			if(s.length()>0) {
				s+=", ";
			}
			s+="yellow";
		}
		return s;
	}

	public boolean getRed() {
		return red;
	}
	
	public boolean getYellow() {
		return yellow;
	}

	public boolean getGreen() {
		return green;
	}
	
}
