package no.uib.inf101.grid;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;

public class Grid implements IGrid {

	@Override
	public Iterator<GridCell> iterator() {
		ArrayList<GridCell> cells = new ArrayList<>();
		for(int row=0; row<rows(); row++) {
			for(int col=0; col<cols; col++) {
				CellPosition pos = new CellPosition(row, col);
				cells.add(new GridCell(pos, get(pos)));
			}
		}
		return cells.iterator();
	}


	
	
	
	
	
	
	
	
	
	
	
	
	private int rows;
	private int cols;
	
	HashMap<CellPosition,Character> map;
	
	public Grid(int rows, int cols) {
		this.rows = rows;
		this.cols = cols;
		map = new HashMap<>();
	}

	public Grid(int rows, int cols, Character defaultValue) {
		this(rows,cols);
		fill(defaultValue);
	}

	private void fill(Character defaultValue) {
		CellPosIterator posIter = new CellPosIterator(rows, cols);
		while(posIter.hasNext()) {
			set(posIter.next(),defaultValue);
		}
	}

	@Override
	public int rows() {
		return rows;
	}

	@Override
	public int cols() {
		return cols;
	}

	@Override
	public void set(CellPosition pos, Character symbol) {
		map.put(pos, symbol);
	}

	@Override
	public Character get(CellPosition pos) {
		if(!positionIsOnGrid(pos))
			throw new IndexOutOfBoundsException("Position must be on the grid");
		return map.get(pos);
	}

	@Override
	public boolean positionIsOnGrid(CellPosition pos) {
		if(pos==null)
			return false;
		if(pos.row()<0 || pos.row()>=rows)
			return false;
		if(pos.col()<0 || pos.col()>=cols)
			return false;
		return true;
	}
}
